## cdemu-daemon-dmo 3.2.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(cdemu-daemon VERSION 3.2.5 LANGUAGES C)

# Additional CMake modules
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

# Versioning
set(CDEMU_DAEMON_INTERFACE_VERSION_MAJOR 7)
set(CDEMU_DAEMON_INTERFACE_VERSION_MINOR 0)

# CMake modules
include(GNUInstallDirs)

# Dependencies
find_package(PkgConfig 0.16 REQUIRED)
find_package(IntlTool 0.21 REQUIRED)
find_package(Gettext 0.15 REQUIRED)

pkg_check_modules(LIBMIRAGE REQUIRED libmirage>=3.2.0 IMPORTED_TARGET)
pkg_check_modules(GLIB REQUIRED glib-2.0>=2.38 gobject-2.0>=2.38 gthread-2.0>=2.38 gio-2.0>=2.38 IMPORTED_TARGET)
pkg_check_modules(AO REQUIRED ao>=0.8.0 IMPORTED_TARGET)

# Global definitions
set(CMAKE_C_STANDARD 99) # Enable C99

if(CMAKE_COMPILER_IS_GNUCC)
    # Enable additional warnings
    add_definitions(-Wall -Wextra -Wshadow -Wmissing-declarations -Wmissing-prototypes -Wnested-externs -Wpointer-arith -Wcast-align)
    add_definitions(-Wno-cast-function-type)
endif()

# Config file
configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)

set(CMAKE_INCLUDE_CURRENT_DIR TRUE)

# *** cdemu-daemon ***
set(cdemu-daemon_SOURCES
    src/audio.c
    src/daemon.c
    src/daemon-dbus.c
    src/device.c
    src/device-commands.c
    src/device-delay.c
    src/device-disc-structures.c
    src/device-features.c
    src/device-kernel-io.c
    src/device-load.c
    src/device-mapping.c
    src/device-mode-pages.c
    src/device-recording.c
    src/error.c
    src/main.c
)

add_executable(cdemu-daemon ${cdemu-daemon_SOURCES})

target_link_libraries(cdemu-daemon PRIVATE PkgConfig::GLIB)
target_link_libraries(cdemu-daemon PRIVATE PkgConfig::LIBMIRAGE)
target_link_libraries(cdemu-daemon PRIVATE PkgConfig::AO)

# Installation
install(TARGETS cdemu-daemon DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES man/cdemu-daemon.8 DESTINATION ${CMAKE_INSTALL_MANDIR}/man8)

# Translations; we use the version provided by our FindIntlTool.cmake
# instead of the gettext version... Note: first two arguments are mandatory,
# the rest is an optional list of languages to process. If no languages
# are given, all POs are processed.
intltool_process_po_files(${PROJECT_SOURCE_DIR}/po ${PROJECT_NAME})

# *** Configuration summary ***
message(STATUS "")
message(STATUS "*** CDEmu daemon v.${PROJECT_VERSION} configuration summary ***")
message(STATUS "Compiler and build info:")
message(STATUS " C compiler: " ${CMAKE_C_COMPILER} ${CMAKE_C_COMPILER_ARG1})
message(STATUS " C flags (Release): " ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_RELEASE})
message(STATUS " C flags (Debug): " ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_DEBUG})
message(STATUS " build type: " ${CMAKE_BUILD_TYPE})
message(STATUS "Installation:")
message(STATUS " install prefix: " ${CMAKE_INSTALL_PREFIX})
message(STATUS "")

=== debian/changelog ===
cdemu-daemon-dmo (3.2.5-dmo2+deb11u3) stable; urgency=medium

  * Increase libmirage-plugin version to 1:3.2.5

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 12 Feb 2023 11:54:27 +0100

cdemu-daemon-dmo (3.2.5-dmo2+deb11u2) stable; urgency=medium

  * Fix postinst and prerm scripts with missing functions.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 11 Feb 2023 18:59:15 +0100

cdemu-daemon-dmo (3.2.5-dmo2+deb11u1) stable; urgency=medium

  * Should Depends on libmirage-plugin
  * Install systemd and dbus service example files (Thanks to  Ильяс Гасанов
    for the bug report).

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 30 Nov 2021 09:19:42 +0100

cdemu-daemon-dmo (3.2.5-dmo2) unstable; urgency=medium

  * Increase libmirage-dev version in Build-Dependency to 3.2.5

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 18 Apr 2021 14:25:47 +0200

cdemu-daemon-dmo (3.2.5-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 18 Apr 2021 14:14:29 +0200

cdemu-daemon-dmo (3.2.4-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 07 Jan 2020 11:01:03 +0100

cdemu-daemon-dmo (3.2.3-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 28 Aug 2019 08:32:21 +0200

cdemu-daemon-dmo (3.2.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 03 Mar 2019 10:53:41 +0100

cdemu-daemon-dmo (3.2.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 08 Jul 2018 15:21:10 +0200

cdemu-daemon-dmo (3.1.0-dmo3) unstable; urgency=medium

  * Must depends on procps for pkill call in prerm script (Thanks Andreas
    Beckmann for the bug report).

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 03 Jul 2017 16:11:17 +0200

cdemu-daemon-dmo (3.1.0-dmo2) unstable; urgency=medium

  * Add intltool in Build-Depends

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 16 Jun 2017 16:40:15 +0200

cdemu-daemon-dmo (3.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 16 Jun 2017 09:42:10 +0200

cdemu-daemon-dmo (3.0.5-dmo2) unstable; urgency=medium

  * Rebuild with PIE

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 12 Mar 2017 15:19:03 +0100

cdemu-daemon-dmo (3.0.5-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 10 Oct 2016 17:23:33 +0200

cdemu-daemon-dmo (3.0.4-dmo2) unstable; urgency=medium

  * Removed unused code in postinst and prerm scripts.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 06 Jan 2016 10:37:00 +0100

cdemu-daemon-dmo (3.0.4-dmo1) unstable; urgency=medium

  * Uplaod to my repository.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 05 Jan 2016 14:07:55 +0100

cdemu-daemon (3.0.4-1) debian; urgency=low

  * Updated to 3.0.4

 -- Rok Mandeljc <rok.mandeljc@gmail.com>  Mon, 21 Dec 2015 12:00:00 +0100

cdemu-daemon (3.0.3-1) debian; urgency=low

  * Updated to 3.0.3
  * Discontinue setting GID on the executable.

 -- Rok Mandeljc <rok.mandeljc@gmail.com>  Sat, 21 Nov 2015 12:00:00 +0100

cdemu-daemon (3.0.2-1) debian; urgency=low

  * 01-dbus-config.diff: Patch D-BUS configuration.
  * Initial Release. Closes: #705409

 -- Henrik Stokseth <henrik@hshq.net>  Sat, 05 Apr 2014 12:00:00 +0100

=== debian/control ===
Source: cdemu-daemon-dmo
Section: misc
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://cdemu.sourceforge.io/about/daemon/
Standards-Version: 4.5.1
Build-Depends: debhelper-compat (= 13), libglib2.0-dev (>= 2.28), libao-dev (>= 0.8.0), 
 libmirage-dev (>= 1:3.2.5~), cmake (>= 3.7.0~), intltool, ninja-build

Package: cdemu-daemon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, procps, dbus-user-session, vhba-dkms (>= 20170610~), libmirage-plugin (>= 1:3.2.5~)
Description: daemon for CDEmu
 This is CDEmu daemon, the daemon part of the CDEmu suite, a free, GPL
 CD/DVD-ROM device emulator for Linux.
 .
 It receives SCSI commands from kernel module and processes them, passing
 the requested data back to the kernel. Daemon implements the actual
 virtual device; one instance per each device registered by kernel module. 
 It uses libMirage, an image access library that is part of CDEmu suite, for
 the image access (e.g. sector reading).
 .
 The daemon registers itself on D-BUS' system or session bus (depending on
 the options passed to it) where it exposes an interface that can be used by
 clients to control it.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_INSTALL_LIBEXECDIR:PATH=lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_test:

## cdemu-daemon-dmo 3.2.6

=== debian/changelog ===
cdemu-daemon-dmo (3.2.6-dmo3) unstable; urgency=medium

  * Increase libmirage-plugin version to 1:3.2.5

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 12 Feb 2023 11:35:51 +0100

cdemu-daemon-dmo (3.2.6-dmo2) unstable; urgency=medium

  * Fix postinst and prerm scripts with missing functions.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 11 Feb 2023 18:48:34 +0100

cdemu-daemon-dmo (3.2.6-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 19 Dec 2021 09:19:44 +0100

cdemu-daemon-dmo (3.2.5-dmo3) unstable; urgency=medium

  * Should Depends on libmirage-plugin
  * Install systemd and dbus service example files (Thanks to  Ильяс Гасанов
    for the bug report).

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 13 Nov 2021 11:04:13 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://cdemu.sourceforge.io/about/daemon/
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Build-Depends: debhelper-compat (= 13), libglib2.0-dev (>= 2.28), libao-dev (>= 0.8.0), 
  libmirage-dev (>= 1:3.2.5~), cmake (>= 3.7.0~), intltool, ninja-build

## cdemu-daemon-dmo 3.2.7

=== debian/changelog ===
cdemu-daemon-dmo (1:3.2.7-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 09 Jul 2024 08:45:35 +0200

cdemu-daemon-dmo (3.2.6-dmo4) unstable; urgency=medium

  * Rebuild for time_t

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 17 Mar 2024 11:44:35 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://cdemu.sourceforge.io/about/daemon/
-Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Standards-Version: 4.7.0
 Build-Depends: debhelper-compat (= 13), libglib2.0-dev (>= 2.28), libao-dev (>= 0.8.0), 
  libmirage-dev (>= 1:3.2.5~), cmake (>= 3.7.0~), intltool, ninja-build

## cdemu-daemon-dmo 3.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,8 @@
-cmake_minimum_required(VERSION 3.7)
-project(cdemu-daemon VERSION 3.2.5 LANGUAGES C)
+cmake_minimum_required(VERSION 3.16)
+project(cdemu-daemon VERSION 3.3.0 LANGUAGES C)
+
+option(ENABLE_LOGIND_SLEEP_HANDLER "Enable support for systemd-logind sleep/hibernation signal handler." ON)
+option(PEDANTIC_MODE "Enable -pedantic flag on gcc compiler" OFF)
 
 # Additional CMake modules
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
@@ -16,8 +19,16 @@
 find_package(IntlTool 0.21 REQUIRED)
 find_package(Gettext 0.15 REQUIRED)
 
+if(ENABLE_LOGIND_SLEEP_HANDLER)
+    # Acquiring sleep inhibitor lock via D-Bus requires GDBus bindings
+    # generated with support for GLib >= 2.64
+    set(MIN_GLIB_VERSION 2.64)
+else()
+    set(MIN_GLIB_VERSION 2.38)
+endif()
+
 pkg_check_modules(LIBMIRAGE REQUIRED libmirage>=3.2.0 IMPORTED_TARGET)
-pkg_check_modules(GLIB REQUIRED glib-2.0>=2.38 gobject-2.0>=2.38 gthread-2.0>=2.38 gio-2.0>=2.38 IMPORTED_TARGET)
+pkg_check_modules(GLIB REQUIRED glib-2.0>=${MIN_GLIB_VERSION} gobject-2.0>=${MIN_GLIB_VERSION} gthread-2.0>=${MIN_GLIB_VERSION} gio-2.0>=${MIN_GLIB_VERSION} IMPORTED_TARGET)
 pkg_check_modules(AO REQUIRED ao>=0.8.0 IMPORTED_TARGET)
 
 # Global definitions
@@ -26,11 +37,13 @@
 if(CMAKE_COMPILER_IS_GNUCC)
     # Enable additional warnings
     add_definitions(-Wall -Wextra -Wshadow -Wmissing-declarations -Wmissing-prototypes -Wnested-externs -Wpointer-arith -Wcast-align)
-    add_definitions(-Wno-cast-function-type)
+    if(PEDANTIC_MODE)
+        add_definitions(-pedantic)
+    endif()
 endif()
 
 # Config file
-configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)
+configure_file(${PROJECT_SOURCE_DIR}/src/config.h.in ${PROJECT_BINARY_DIR}/config.h)
 
 set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
 
@@ -53,11 +66,51 @@
     src/main.c
 )
 
+# GDBus bindings for org.freedesktop.login1
+if(ENABLE_LOGIND_SLEEP_HANDLER)
+    # gdbus-codegen
+    pkg_get_variable(GDBUS_CODEGEN gio-2.0 gdbus_codegen)
+    if(GDBUS_CODEGEN STREQUAL "")
+        message(FATAL_ERROR "Could not gdbus-codegen executable!")
+    else()
+        message(STATUS "Found gdbus-codegen: ${GDBUS_CODEGEN}")
+    endif()
+
+    add_custom_command(
+        OUTPUT ${PROJECT_BINARY_DIR}/freedesktop-login-manager.h ${PROJECT_BINARY_DIR}/freedesktop-login-manager.c
+        COMMAND ${GDBUS_CODEGEN}
+        --interface-prefix org.freedesktop.login1 --c-generate-autocleanup all --c-namespace FreedesktopLogin --glib-min-required ${MIN_GLIB_VERSION}
+        --header --pragma-once --output ${PROJECT_BINARY_DIR}/freedesktop-login-manager.h ${PROJECT_SOURCE_DIR}/src/org.freedesktop.login1.xml
+        COMMAND ${GDBUS_CODEGEN}
+        --interface-prefix org.freedesktop.login1 --c-generate-autocleanup all --c-namespace FreedesktopLogin --glib-min-required ${MIN_GLIB_VERSION}
+        --body --pragma-once --output ${PROJECT_BINARY_DIR}/freedesktop-login-manager.c ${PROJECT_SOURCE_DIR}/src/org.freedesktop.login1.xml
+        DEPENDS ${PROJECT_SOURCE_DIR}/src/org.freedesktop.login1.xml
+        COMMENT "Generate GDBus bindings for org.freedesktop.login1"
+    )
+
+    list(APPEND cdemu-daemon_SOURCES
+        # auto-generated
+        ${PROJECT_BINARY_DIR}/freedesktop-login-manager.h
+        ${PROJECT_BINARY_DIR}/freedesktop-login-manager.c
+    )
+
+    # Before GLib 2.74, the `gio/gunixfdlist.h` header (required by the
+    # above GDBus bindings) belonged to UNIX-specific GIO interfaces,
+    # exposed through `gio-unix-2.0.pc` pkg-config file.
+    if(GLIB_glib-2.0_VERSION VERSION_LESS "2.74")
+        pkg_check_modules(GIO_UNIX REQUIRED gio-unix-2.0>=${MIN_GLIB_VERSION} IMPORTED_TARGET)
+    endif()
+endif()
+
 add_executable(cdemu-daemon ${cdemu-daemon_SOURCES})
 
 target_link_libraries(cdemu-daemon PRIVATE PkgConfig::GLIB)
 target_link_libraries(cdemu-daemon PRIVATE PkgConfig::LIBMIRAGE)
 target_link_libraries(cdemu-daemon PRIVATE PkgConfig::AO)
+
+if(ENABLE_LOGIND_SLEEP_HANDLER AND GLIB_glib-2.0_VERSION VERSION_LESS "2.74")
+    target_link_libraries(cdemu-daemon PRIVATE PkgConfig::GIO_UNIX)
+endif()
 
 # Installation
 install(TARGETS cdemu-daemon DESTINATION ${CMAKE_INSTALL_BINDIR})
@@ -71,12 +124,10 @@
 
 # *** Configuration summary ***
 message(STATUS "")
-message(STATUS "*** CDEmu daemon v.${PROJECT_VERSION} configuration summary ***")
-message(STATUS "Compiler and build info:")
-message(STATUS " C compiler: " ${CMAKE_C_COMPILER} ${CMAKE_C_COMPILER_ARG1})
-message(STATUS " C flags (Release): " ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_RELEASE})
-message(STATUS " C flags (Debug): " ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_DEBUG})
-message(STATUS " build type: " ${CMAKE_BUILD_TYPE})
+message(STATUS "*** CDEmu daemon v${PROJECT_VERSION} configuration summary ***")
 message(STATUS "Installation:")
 message(STATUS " install prefix: " ${CMAKE_INSTALL_PREFIX})
+message(STATUS "Options:")
+message(STATUS " pedantic mode: " ${PEDANTIC_MODE})
+message(STATUS " systemd-logind sleep/hibernation signal handler support: " ${ENABLE_LOGIND_SLEEP_HANDLER})
 message(STATUS "")

=== debian/changelog ===
cdemu-daemon-dmo (1:3.3.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 15 Feb 2026 17:17:28 +0100

cdemu-daemon-dmo (1:3.2.7-dmo1+b1) unstable; urgency=medium

  * Rebuild for PAC/BTI support; no source changes.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 06 Nov 2024 08:06:01 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,15 @@
 Source: cdemu-daemon-dmo
 Section: misc
-Priority: optional
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://cdemu.sourceforge.io/about/daemon/
-Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Build-Depends: debhelper-compat (= 13), libglib2.0-dev (>= 2.28), libao-dev (>= 0.8.0), 
- libmirage-dev (>= 1:3.2.5~), cmake (>= 3.7.0~), intltool, ninja-build
+ libmirage-dev (>= 1:3.3.0~), cmake (>= 3.7.0~), intltool, ninja-build,
 
 Package: cdemu-daemon
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, procps, dbus-user-session, vhba-dkms (>= 20170610~), libmirage-plugin (>= 1:3.2.5~)
+Depends: ${shlibs:Depends}, ${misc:Depends}, procps, dbus-user-session, vhba-dkms (>= 20170610~), libmirage-plugin (>= 1:3.3.0~),
 Description: daemon for CDEmu
  This is CDEmu daemon, the daemon part of the CDEmu suite, a free, GPL
  CD/DVD-ROM device emulator for Linux.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_INSTALL_LIBEXECDIR=lib/$(DEB_HOST_MULTIARCH)

#	exit 1

override_dh_auto_test:

=== debian/watch ===
version=4

https://github.com/cdemu/cdemu/tags \
.*cdemu-daemon-@ANY_VERSION@@ARCHIVE_EXT@
